// dllai.cpp : Defines the exported functions for the DLL application.
//

#define _CRT_SECURE_NO_WARNINGS
#include "ai.h"
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include "windows.h"

#define AI_DLL_VERSION 1
#define DLLEXPORT extern "C" __declspec(dllexport)

char g_result[1024];

char* result(std::string r)
{
    return strcpy( g_result, r.c_str() );
}

DLLEXPORT
int AIDllVersion()
{
    return AI_DLL_VERSION;
}

DLLEXPORT
char* AIName( int level ) {
    char name[200];
    sprintf( name, "LV%d", level);
    return result( std::string("Baka ") + name );
}

DLLEXPORT
char* TetrisAI(int overfield[], int field[], int field_w, int field_h, int b2b, int combo,
               char next[], char hold, char active, int x, int y, int spin,
               bool canhold, bool can180spin, int upcomeAtt, int comboTable[], int maxDepth, int level, int player)
{
    AI::GameField gamefield(field_w, field_h); // always 10 x 22
    std::vector<AI::Gem> gemNext;
    std::map<char, int> gemMap;
    gemMap[' '] = 0;
    gemMap['I'] = 1;
    gemMap['T'] = 2;
    gemMap['L'] = 3;
    gemMap['J'] = 4;
    gemMap['Z'] = 5;
    gemMap['S'] = 6;
    gemMap['O'] = 7;
    for ( int iy = 0; iy <= field_h; ++iy ) {
        gamefield.row[iy] = field[iy];
    }
    for ( int iy = 0; iy < 8; ++iy ) {
        gamefield.row[-iy-1] = overfield[iy];
    }
    gamefield.m_hold = gemMap[hold];
    gamefield.b2b = b2b;
    gamefield.combo = combo;
    for ( int i = 0; i < maxDepth; ++i) {
        gemNext.push_back( AI::getGem(gemMap[next[i]], 0) );
    }
    for ( int i = 0; i < 100; ++i) {
        if ( comboTable[i] < 0 ) {
            AI::setComboList( std::vector<int>(comboTable, comboTable + i - 1) );
            break;
        }
    }
    AI::setSpin180(can180spin);

    // player is the player number, for randomize or something else, to make different player do the different thing
    AI::Moving mov = AI::AISearch(gamefield, AI::getGem(gemMap[active], spin), x, y, gemNext, canhold, upcomeAtt, level, player);

    std::map<int, char> outMap;
    outMap[AI::Moving::MOV_NULL] = ' ';
    outMap[AI::Moving::MOV_L] = 'l';
    outMap[AI::Moving::MOV_R] = 'r';
    outMap[AI::Moving::MOV_LL] = 'L';
    outMap[AI::Moving::MOV_RR] = 'R';
    outMap[AI::Moving::MOV_D] = 'd';
    outMap[AI::Moving::MOV_DD] = 'D';
    outMap[AI::Moving::MOV_LSPIN] = 'z';
    outMap[AI::Moving::MOV_SPIN2] = 'x';
    outMap[AI::Moving::MOV_RSPIN] = 'c';
    outMap[AI::Moving::MOV_HOLD] = 'v';
    outMap[AI::Moving::MOV_DROP] = 'V';
    std::string out;
    for ( size_t i = 0; i < mov.movs.size(); ++i ) {
        out.push_back(outMap[mov.movs[i]]);
    }
    return result(out);
}

